Bug 429609 - Review Request: perl-CGI-SpeedyCGI - Speed up perl scripts by running them persistently
Review Request: perl-CGI-SpeedyCGI - Speed up perl scripts by running them pe...
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
All Linux
low Severity low
: ---
: ---
Assigned To: Jason Tibbitts
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2008-01-21 17:29 EST by Robert Scheck
Modified: 2008-05-04 15:56 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-05-04 15:56:15 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tibbs: fedora‑review+
kevin: fedora‑cvs+

Attachments (Terms of Use)

  None (edit)
Description Robert Scheck 2008-01-21 17:29:56 EST
Spec URL: http://labs.linuxnetz.de/bugzilla/perl-CGI-SpeedyCGI.spec
SRPM URL: http://labs.linuxnetz.de/bugzilla/perl-CGI-SpeedyCGI-2.22-1.src.rpm
Description: Speed up perl scripts by running them persistently
SpeedyCGI is a way to run perl scripts persistently, which can make them run 
much more quickly. After the script is initially run, instead of exiting, the 
perl interpreter is kept running. During subsequent runs, this interpreter is 
used to handle new executions instead of starting a new perl interpreter each 
time. It is a very fast frontend program, written in C, is executed for each 

Maybe Joe can have a look to my Apache specific patch, you're much more close 
to Apache hacking and I don't use the Apache part of perl-CGI-SpeedyCGI...
Comment 1 Jason Tibbitts 2008-01-24 21:18:17 EST
I can review the packaging here, but I'm not qualified to evaluate the patch for
apache 2.2.  However, I do note that it has a few hunks fewer than the one in
the upstream bug tracker: http://rt.cpan.org/Public/Bug/Display.html?id=23920

Perhaps you could evaluate the additional apr_filepath_name_get changes there.
Comment 2 Robert Scheck 2008-01-25 02:16:09 EST
That's why I'm trying to move the Apache patch review to Joe. Yesterday I 
noticed, that PLD Linux has (more or less) the same patch as I wrote - they
are using while, I'm using foreach. But that patch thing shouldn't hold up
the review itself, shouldn't it?
Comment 3 Joe Orton 2008-01-25 10:40:58 EST
The patch will compile and work.  mod_speedycgi2.c is a rather stale fork of
upstream mod_cgi.c and lacks the improvements and bug fixes from over a couple
of years.

w.r.t to code changed in the patch itself, the second loop is OK, but the
discard_script_output loop is sub-optimal, it should look something like this:

    while ((e = APR_BRIGADE_FIRST(bb)) != APR_BRIGADE_SENTINEL(bb)) {
        if (APR_BUCKET_IS_EOS(e)) {

        rv = apr_bucket_read(e, &buf, &len, APR_BLOCK_READ);
        if (rv != APR_SUCCESS) {


Comment 4 Robert Scheck 2008-01-25 12:06:16 EST
Well, should I better take this one? http://cvs.pld-linux.org/cgi-bin/
type=text%2Fplain -- it looks more like yours.
Comment 5 Jason Tibbitts 2008-01-26 13:29:00 EST
I'll completely sidestep the issue of that patch.  However, a check of the
licensing reveals something that troubles me.  The following file starts with
the usual GPL license block and then says "/* Based on apache's mod_cgi.c */"
and goes on to quote what I think is the 1.0 Apache license:

My understanding is that it is not remotely kosher to relicense ASL code (any
version) as GPLv2.  Maybe v3, but I'm no expert.  Blocking FE-Legal so someone
who understands this can take a look.  However, I've already done most of this
review so I'll go ahead and finish it up and if the legal folks say it's OK then
at least the work won't be wasted.

rpmlint says:
  mod_speedycgi.x86_64: W: no-documentation
which is OK.  However, becase this requires the end user to make modification to
the installed .conf file, could you add a README.Fedora file indicating what the
user needs to do to make things work?

* source files match upstream:
* package meets naming and versioning guidelines.
* specfile is properly named, is cleanly written and uses macros consistently.
* summary is OK.
* description is OK.
* dist tag is present.
* build root is OK.
? license field matches the actual license.
? license is open source-compatible.
* license text included in package.
* latest version is being packaged.
* BuildRequires are proper.
* compiler flags are appropriate.
* %clean is present.
* package builds in mock (rawhide, x86_64).
* package installs properly
* debuginfo package looks complete.
* rpmlint has acceptable complaints.
* final provides and requires are sane:
   config(mod_speedycgi) = 2.22-1.fc9
   mod_speedycgi = 2.22-1.fc9
   config(mod_speedycgi) = 2.22-1.fc9
   httpd >= 2.0.40
   httpd-mmn = 20051115
   perl-CGI-SpeedyCGI = 2.22-1.fc9

   perl(CGI::SpeedyCGI) = 2.22
   perl-CGI-SpeedyCGI = 2.22-1.fc9

* %check is not present; no test suite upstream.  I have not attempted to test 
* no shared libraries are added to the regular linker search paths.
* owns the directories it creates.
* doesn't own any directories it shouldn't.
* no duplicates in %files.
* file permissions are appropriate.
* no scriptlets present.
* code, not content.
* documentation is small, so no -doc subpackage is necessary.
* %docs are not necessary for the proper functioning of the package.
* no headers.
* no pkgconfig files.
* no static libraries.
* no libtool .la files.
Comment 6 Tom "spot" Callaway 2008-02-18 16:10:08 EST
The only way this code is kosher is if we leverage the + in the license to make
it GPLv3, since GPLv2 is incompatible with ASL 1.0.

Please contact upstream and let them know about this issue, and urge them to
either use GPLv3+ or relicense to avoid the issue.

For the here and now, mark the license tag as "GPLv3+". Lifting FE-Legal.
Comment 7 Robert Scheck 2008-02-19 10:11:18 EST
Of course I'll inform upstream. And what are we missing now to pass the review?
Comment 8 Jason Tibbitts 2008-02-21 16:09:43 EST
I really thought I had sent a reply to this ticket.

Anyway, if you agree to the change of the license tag, just say so and I'll be
happy to approve this package.  Or if you'd prefer to hear back from upstream
first, just say so and we'll wait.
Comment 9 Robert Scheck 2008-02-21 18:51:06 EST
I'll change the license tag, of course.
Comment 10 Jason Tibbitts 2008-02-21 19:38:08 EST
OK, cool.

Comment 11 Robert Scheck 2008-05-04 08:57:27 EDT
New Package CVS Request
Package Name: perl-CGI-SpeedyCGI
Short Description: Speed up perl scripts by running them persistently
Owners: robert
Branches: F-7 F-8 F-9 EL-4 EL-5
Cvsextras Commits: no
Comment 12 Kevin Fenzi 2008-05-04 13:16:37 EDT
cvs done.
Comment 13 Robert Scheck 2008-05-04 15:56:15 EDT
38921 (perl-CGI-SpeedyCGI): Build on target fedora-4-epel succeeded.
38920 (perl-CGI-SpeedyCGI): Build on target fedora-5-epel succeeded.

Package: perl-CGI-SpeedyCGI-2.22-2.fc7 Tag: dist-fc7-updates-candidate Status:
Package: perl-CGI-SpeedyCGI-2.22-2.fc8 Tag: dist-f8-updates-candidate Status:
Package: perl-CGI-SpeedyCGI-2.22-2.fc9 Tag: dist-f9-updates-candidate Status:
Package: perl-CGI-SpeedyCGI-2.22-2.fc10 Tag: dist-f10 Status: complete 

Note You need to log in before you can comment on or make changes to this bug.